import scala.collection.mutable.Stack

abstract class MVar[A] private (var value: Option[A]) {
  private takeStack: Stack[Promise[A]]
  private putStack: Stack[(A,Promise[Unit])]

  def take: Future[A] = synchronized { value match {
    case None =>    
      val p = Promise[A]
      takeStack.push(p)
      p.future
    case Some(a) =>
      if (putStack.isEmpty) {
        value = None
      } else {
        putStack.pop
      }
      Future.successfull(a)
  } }

  def put(a: A): Future[Unit] = synchronized {
    if (value.isEmpty) {
      if (takeStack.isEmpty) {
        value = Some(a)
      } else {
        takeStack.
      }
      Future.sucessfull(())
    } else {
      val p = Promise[Unit]
      putStack.push((a,p))
      p.future
    }
  }
}

object MVar {
  def apply[A]() = new MVar[A](None)
  def apply[A](a: A) = new MVar[A](Some(a))
}