module MaybeMonad where

-- Maybe and Either Monad Instances

import Prelude hiding (Maybe, Just, Nothing, Either, Left, Right)

data Maybe alpha = Just alpha | Nothing

instance Functor Maybe where
  fmap f (Just a) = Just (f a)
  fmap f Nothing  = Nothing

instance Applicative Maybe where
  pure a = Just a
  Just f <*> Just b = Just (f b)
  _ <*> _ = Nothing

instance Monad Maybe where
  Just a >>= g  = g a
  Nothing >>= g = Nothing
  return = Just

data Either delta beta = Left delta | Right beta

instance Functor (Either delta) where
  fmap f (Right b) = Right (f b)
  fmap f (Left  a) = Left  a

instance Applicative (Either delta) where
  pure    = Right 
  Right f <*> Right b = Right (f b)
  _ <*> Left b = Left b

instance Monad (Either delta) where
  Right b >>= g = g b
  Left a  >>= _ = Left a
  return = Right
