module ReaderMonad where

newtype Reader sigma alpha = Rd { run :: sigma -> alpha }

instance Functor (Reader sigma) where
  fmap f r = Rd (f. run r)

instance Applicative (Reader sigma) where
  pure a = Rd (\s-> a)
  fr <*> fa = Rd (\s-> (run fr s) (run fa s))

instance Monad (Reader sigma) where
  return a = Rd (\s-> a)
  r >>= f  = Rd (\s-> run (f ((run r) s)) s)
  
get :: (sigma-> alpha) -> Reader sigma alpha
get f = Rd f

local :: (sigma-> sigma)-> Reader sigma alpha-> Reader sigma alpha
local f r = Rd (run r. f)
