module STExample1 where

import ST1Monad -- also works with ST2Monad
import Data.Char(toLower, isUpper)

-- This function is like toLower, but also counts the number of upper-case
-- characters converted to lower.
cntToLower :: String-> (String, Int)
cntToLower s = runST $ do
  r<- newRef 0
  s<- cntToL s r
  c<- readRef r
  return (s, c)
  
-- Main function (type signature commented so it works for both ST1 and ST2)
-- cntToL :: String-> Ref Int-> ST Int String -- ST1
-- cntToL :: String-> Ref Int-> ST String -- ST2
cntToL [] r = return []
cntToL (x:xs) r
  | isUpper x =  do ys<- cntToL xs r
                    c <- readRef r
                    writeRef r (c+1)
                    return (toLower x: ys)
  | otherwise =  do { ys<- cntToL xs r; return (x: ys) }

-- This breaks our state:b
ex1 :: String
ex1 = runST $ readRef (runST $ newRef "foo")
